三数之和(双指针)

15. 三数之和 - 力扣(LeetCode)

题目描述

给你一个整数数组 nums ,判断是否存在三元组 [nums[i], nums[j], nums[k]] 满足 i != j、i != k 且 j != k ,同时还满足 nums[i] + nums[j] + nums[k] == 0 。请

你返回所有和为 0 且不重复的三元组。

**注意:**答案中不可以包含重复的三元组。

样例输入

示例 1:

复制代码
输入:nums = [-1,0,1,2,-1,-4]
输出:[[-1,-1,2],[-1,0,1]]
解释:
nums[0] + nums[1] + nums[2] = (-1) + 0 + 1 = 0 。
nums[1] + nums[2] + nums[4] = 0 + 1 + (-1) = 0 。
nums[0] + nums[3] + nums[4] = (-1) + 2 + (-1) = 0 。
不同的三元组是 [-1,0,1] 和 [-1,-1,2] 。
注意,输出的顺序和三元组的顺序并不重要。

示例 2:

复制代码
输入:nums = [0,1,1]
输出:[]
解释:唯一可能的三元组和不为 0 。

示例 3:

复制代码
输入:nums = [0,0,0]
输出:[[0,0,0]]
解释:唯一可能的三元组和为 0 。

题解

整体思路

如图所示,代码的整理思路是

  • 对数组进行排序,使用指针i遍历a,指针left遍历b,指针遍历c。遍历时,固定指针i,之后使用双指针法遍历b与c,
  • 若numsi+numsleft+numsright>0,则right--
  • 若numsi+numsleft+numsright<0,则left++

去重

由于数组中有重复元素,而题目中要求的结果是不重复的三元组,因此要对a、b、c进行去重,需要注意的是,去重指的是单独的a或者单独的b或者单独的c不能重复,而不是指a与b不能相同

关于对a的去重

对a进行去重时,必须使用以下语句进行判断是否重复

cpp 复制代码
nums[i]==nums[i-1]

而不能使用

cpp 复制代码
nums[i]==nums[i+1]

因为,指针i遍历的是a,指针left紧跟i指针后,遍历的是b,如果使用numsi==numsi+1来判断是否重复,就相当于判断numsi与numsleft是否相等,

如三元组-1,-1,2,i指针指向-1,left指向-1,right指向2,如下图所示,如果使用numsi==numsi+1进行去重,很显然会错过这个符合条件的三元组

对b和c的去重

除此以外,对b和c的去重,必须要先确定b和c的值之后再进行去重,而不能使用以下代码逻辑,先对b和c进行去重,之后再确定b和c的值,因为这样会错过三元组0,0,0的结果

cpp 复制代码
while(l<r)
{
	//不能在这里对b和c进行去重
    while(l<r && nums[r]==nums[r-1])
    	r--;
    while(l<r && nums[l]==nums[l+1])
    	l++;

    int sum=nums[i]+nums[l]+nums[r];
    if(sum>0)
    	r--;
    else if(sum<0)
    	l++;
    else
    {
        res.emplace_back(vector<int>{nums[i],nums[l],nums[r]});
        r--;
    	l++;
    }

}

代码

cpp 复制代码
class Solution {
public:
    vector<vector<int>> threeSum(vector<int>& nums) {
        //对数组进行排序后才能使用双指针
        sort(nums.begin(),nums.end());
        int n=nums.size();
        vector<vector<int>> res;
    
        for(int i=0;i<n;i++)//固定a
        {
            if(nums[i]>0)
                return res;

            //对a进行去重
            if(i>0 && nums[i]==nums[i-1])
                continue;

            //寻找b与c
            int l=i+1,r=n-1;
            while(l<r)
            {
                int sum=nums[i]+nums[l]+nums[r];
                if(sum>0)
                    r--;
                else if(sum<0)
                    l++;
                else
                {
                    //确定b和c的值
                    res.emplace_back(vector<int>{nums[i],nums[l],nums[r]});
                    //对b和c进行去重
                    while(l<r && nums[r]==nums[r-1])
                        r--;
                    while(l<r && nums[l]==nums[l+1])
                        l++;
                    r--;
                    l++;
                }
                
            }
        }
        return res;
    }
};
相关推荐
lengxuenong15 分钟前
区间覆盖问题 · 简明学习手册1
java·学习·算法
明志数科27 分钟前
人类视频与机器人示教的数据配比:分层训练的数据采购与采集设计
人工智能·算法
Ivanqhz39 分钟前
MoE 原理、TC/EC 路由、LSH-MoE 与负载均衡浅析
运维·网络·人工智能·深度学习·算法·机器学习·负载均衡
Sarvartha42 分钟前
栈的四则运算、栈的递归应用
数据结构·算法
stolentime1 小时前
CF2277E Tree Guessing题解
c++·算法·贪心算法·交互·ad-hoc
逐光者9331 小时前
杨氏模量:从定义到工程应用
算法
荆棘鸟智能2 小时前
扬尘在线监测数据接入与异常清洗:从断点补传到质量审计
人工智能·算法·系统架构
动词ing3 小时前
【题目练习】旋转图像
算法
天疆说3 小时前
【无标题】
算法
GG.WinGel3 小时前
三元组中心问题
java·数据结构·算法·青少年编程·蓝桥杯